#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
#
# Weitere Lizenz: GPL V3.0
# Siehe http://www.gnu.org/licenses/gpl-3.0.html
#
# $Id: schwarzesbrett.py 582 2014-04-19 19:19:24Z pieper $
class Schueler:
	def __init__ (self, heisst):
		self.meinZettel= None
		self.tafel= None
		self.setzeName(heisst)

	def setzeName(self, neuerName):
		self.name=neuerName
	def gibName(self):
		return self.name	
		
	def setzeTafel(self, dieseTafel):
		self.tafel= dieseTafel		
	def gibTafel(self):
		return self.tafel	
		
	def erzeugeZettel(self):
		self.meinZettel= Zettel()

	def schreibeZettel(self,text):
		self.meinZettel.schreibeText(text)
		
	def gibZettel(self):
		return self.meinZettel	

	def haengeZettelAuf(self, wohin):
		wohin.nimmZettelAuf(self.meinZettel)
		self.setzeTafel(wohin)

	def schaueAn(self, was):
		self.setzeTafel(was)
	
	def nimmZettelAb(self):
		self.gibTafel().entferneZettel( self.gibZettel() )

	def wirfZettelWeg(self):
		self.meinZettel.zerstoere()


class Zettel:
	def __init__(self):
		self.schreibeText("")
		
	def schreibeText(self, neuerText):
		self.text=neuerText
		
	def gibText(self):
		return self.text
		
	def zerstoere(self):
		self.schreibeText("")		
	
		
class InfoBrett:
	def __init__(self,ueberschrift):
		self.setzeBezeichnung(ueberschrift)
		self.zettel= list()
		
	def setzeBezeichnung(self,neueBezeichnung):
		self.bezeichnung= neueBezeichnung
		
	def nimmZettelAuf(self, meinZettel):
		self.zettel.append(meinZettel)
		
	def zeigeOeffentlich(self):
		print("I n f o b r e t t  --- ", self.bezeichnung)
		if self.zettel.__len__()==0:
			print("... ist leer")
		for einZettel in self.zettel:
			print ( einZettel.gibText() )

	def entferneZettel(self, dieserZettel):
		if dieserZettel in self.zettel:
			self.zettel.remove(dieserZettel)

if __name__ == "__main__":
	infoboard= InfoBrett("WBGE - Oberstufe")
	infoboard.zeigeOeffentlich()

	schueler1= Schueler("Eva")
	schueler2= Schueler("Willi")
	schueler3= Schueler("Marie")

	zettel1= schueler1.erzeugeZettel()
	schueler1.schreibeZettel("Mein Füller ...")
	schueler1.haengeZettelAuf(infoboard)
	
	zettel2= schueler2.erzeugeZettel()
	schueler2.schreibeZettel("Morgen fällt die Schule aus ...")
	schueler2.haengeZettelAuf(infoboard)
	
	schueler3.schaueAn(infoboard)
	schueler3.gibTafel().zeigeOeffentlich()
	
	schueler1.nimmZettelAb()
	infoboard.zeigeOeffentlich()

	schueler1.gibTafel().entferneZettel(zettel1)
	schueler1.wirfZettelWeg()
	infoboard.zeigeOeffentlich()


